<script>
import { ref, computed, onMounted, reactive } from "vue";
import useValidate from "@vuelidate/core";
import store from "@/store"
import { required, email, minLength, sameAs, helpers } from "@vuelidate/validators";
import { HTTP } from "@/components/common/HttpCommon";

import Loading from '@/components/item/Loading.vue';
export default {
  components: { Loading },
  name: 'RequestProductForm',
  props: {
    title: String,
    data: Object
  },
  data(){
    return{
      formTitle : this.title,
      formData : this.data,
      addStatus : this.title == 'Add Request',
      formId : this.title != 'Add Request' ? this.data.id : null,
      viewStatus : this.title == 'View Detail Request'
    }
  },
  setup() {
    const success = ref(null);
    const loading = ref(false);
    const error = ref(null);
    const state = reactive({
      name: '',
      description: '',
      unit: '',
      weight: '',
      categoryProduct: '',
      requestStatus:'',
      userId : ''
    });
    const rules = computed(() => {
      return {
        name: { required },
        description: { required },
        unit: { required },
        weight: { required },
        categoryProduct: { required },
        requestStatus:{}
      }
    });
    const v$ = useValidate(rules, state)
    async function fetchData() {
      loading.value = true;
      const result = await HTTP.get(`users`).then(response => {
        console.log(response.data)
      })
          .catch(e => {
            console.log(e)
          })
      loading.value = false;
    }
    async function saveData() {
      loading.value = true;
      const requestData = {
        name: state.name,
        description: state.description,
        unit: state.unit,
        weight: state.weight,
        categoryProduct: state.categoryProduct,
        userId: store.state.userId
      }
      if(this.formId){
        const result = await HTTP.post('products/request/' + this.formId + '/' + this.state.requestStatus).then(response => {
          success.value = response.data.message
          setTimeout(() => {
            this.$emit('form-modal-done')
          }, 1000)
        })
            .catch(e => {
              const jsonError = e.toJSON();
              error.value = jsonError.message

            })
      } else {
        console.log("request")
        const result = await HTTP.post(`products/request`, JSON.stringify(requestData)).then(response => {
          success.value = response.data.message
          setTimeout(() => {
            this.$emit('form-modal-done')
          }, 1000)
        })
            .catch(e => {
              const jsonError = e.toJSON();
              error.value = jsonError.message

            })
      }
      loading.value = false;
    }

    onMounted(() => {
      // console.log(saveData());
    });

    return {
      success,
      loading,
      error,
      state,
      v$,
      saveData
    };
  },methods: {
    onSubmit(e) {
      this.v$.$validate()
      if(!this.v$.$error){
        this.saveData()
      }
      e.preventDefault()
    },
    onReset() {
      e.preventDefault()
    }
  },mounted(){
    if(!this.addStatus){
      this.state.name = this.formData.name
      this.state.description = this.formData.description
      this.state.unit = this.formData.unit
      this.state.weight = this.formData.weight
      this.state.categoryProduct = this.formData.categoryProduct
      this.state.requestStatus = this.formData.requestStatus
    }
  }
}
</script>
<template>
  <Loading v-if="loading"/>
  <b-form v-if="!loading" @submit="onSubmit" @reset="onReset">
    <div class="card">
      <div class="card-header d-flex justify-content-between">
        <div class="header-title">
          <h4 class="card-title">
            {{formTitle}}
          </h4>
        </div>
        <a class="badge bg-warning mr-2" href="#" @click="$emit('close-modal')"><i class="ri-arrow-go-back-fill mr-0"></i></a>
      </div>
      <div class="col-md-12" v-if="error || success">
        <div class="alert alert-danger" v-if="error">
          <div class="iq-alert-text">
            {{error}}
          </div>
        </div>
        <div class="alert alert-success" v-if="success">
          <div class="iq-alert-text">
            {{success}}
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-12">
          <div class="form-group">
            <label>Name *</label>
            <input v-model="state.name" type="text" class="form-control" :class = "{'is-invalid' : v$.name.$error }" placeholder="Enter Name" data-errors="Please Enter Name." :disabled = "viewStatus" required>
            <div class="help-block with-errors" v-if="v$.name.$error" >
              <div class="alert alert-danger">
                <div class="iq-alert-text">
                  {{v$.name.$errors[0].$message}}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>Description *</label>
            <textarea v-model="state.description" type="text" class="form-control" placeholder="Enter Code" data-errors="Please Enter Description." :disabled = "viewStatus" required></textarea>
            <div class="help-block with-errors" v-if="v$.description.$error" >
              <div class="alert alert-danger">
                <div class="iq-alert-text">
                  {{v$.code.$errors[0].$message}}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>Unit *</label>
            <select v-model="state.unit" name="type" class="form-control" :disabled = "viewStatus" required >
              <option>pcs</option>
              <option>kotak</option>
              <option>pak</option>
              <option>strip</option>
              <option>sachet</option>
            </select>
            <div class="help-block with-errors"  v-if="v$.unit.$error" >
              <div class="alert alert-danger">
                <div class="iq-alert-text">
                  {{v$.unit.$errors[0].$message}}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>Weight *</label>
            <input v-model="state.weight" type="number" class="form-control" placeholder="Enter Price" data-errors="Please Enter Email." :disabled = "viewStatus" required>
            <div class="help-block with-errors"  v-if="v$.weight.$error" >
              <div class="alert alert-danger">
                <div class="iq-alert-text">
                  {{v$.price.$errors[0].$message}}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-12">
          <label>Category *</label>
          <select v-model="state.categoryProduct" name="type" class="form-control" :disabled = "viewStatus" >
            <option value="MAKANAN">Makanan</option>
            <option value="MINUMAN">Minuman</option>
            <option value="KOSMETIK">Kosmetik</option>
            <option value="OBAT_OBATAN">Obat</option>
            <option value="BARANG">Barang Lain</option>
          </select>
          <div class="help-block with-errors"  v-if="v$.categoryProduct.$error" :disabled = "viewStatus" >
            <div class="alert alert-danger">
              <div class="iq-alert-text">
                {{v$.categoryProduct.$errors[0].$message}}
              </div>
            </div>
          </div>
        </div>
        <div v-if="!addStatus" class="col-md-12">
          <label>Status *</label>
          <select v-model="state.requestStatus" name="type" class="form-control" :disabled = "viewStatus" >
            <option value="REJECTED">Rejected</option>
            <option value="ACCEPTED">Accepted</option>
          </select>
          <div class="help-block with-errors"  v-if="v$.requestStatus.$error" :disabled = "viewStatus" >
            <div class="alert alert-danger">
              <div class="iq-alert-text">
                {{v$.requestStatus.$errors[0].$message}}
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="col-md-12">
        <button v-if="!viewStatus" type="submit" class="btn btn-primary btn-block">Save</button>
        <button v-if="!viewStatus && addStatus" type="reset" class="btn btn-danger btn-block">Reset</button>
      </div>
    </div>
  </b-form>
</template>
<style scoped>
.col-md-12:nth-child(2) > .form-group:first-child{
  margin-top: 1rem;
}
.row{
  padding: 1rem;
}
</style>
